@ECHO off
REM Installation for MC interim fix
REM RenLei 07-01-26
REM you have to set the following variable
REM according to your system

CLS
SET SILENT=false
IF "%1a"=="a" GOTO no_param
IF NOT EXIST %1\License ECHO ****** Could not find directory %1\License ******
IF NOT EXIST %1\License GOTO no_param
SET ITM_HOME=%1
IF NOT "%2a"=="a" SET SILENT=true
GOTO genUninstall

:genUninstall
SET uninst=patch_uninstall.bat
SET missed=no
IF EXIST %uninst% DEL %uninst%
IF EXIST backup RD /s /q backup
MD backup
MD backup\InstallITM
MD backup\InstallITM\ver

SET ITMVER=
IF EXIST %ITM_HOME%\InstallITM\ver (GOTO getVersion) ELSE (ECHO ******CAN NOT FIND VERSION INFO******)

rem IF "%ITMVER%a"=="a" GOTO endpro
:gotVersion
ECHO %ITMVER% is found under %ITM_HOME% 
REM echo ITMVER=%ITMVER%
IF NOT EXIST %ITMVER% (
	ECHO This patch couldnot support  %ITMVER% ! Please contact IBM for other patch.
	GOTO endpro
)
ECHO Backup old files first
IF NOT "%SILENT%"=="true" PAUSE
@XCOPY /E /I %ITMVER%\CNB backup\CNB
@XCOPY /E /I %ITMVER%\CNP backup\CNP
@XCOPY /E /I %ITMVER%\CNPS backup\CNPS
@XCOPY /E /I %ITMVER%\CMS backup\CMS
@XCOPY /E /I %ITMVER%\TMAITM6 backup\TMAITM6
@XCOPY /E /I %ITMVER%\InstallITM backup\InstallITM
FOR /F %%i IN (%ITMVER%\file_list.txt) DO ( IF EXIST %ITM_HOME%\%%i ( @xcopy /I /E /Y %ITM_HOME%\%%i backup\%%i ) ELSE ( SET missed=yes ) )
REM BACKUP VERSION FILES
FOR /F %%i IN (version_files.txt) DO ( IF EXIST %ITM_HOME%\%%i ( @copy /V /Y %ITM_HOME%\%%i backup\%%i ) )
ECHO Generate uninstall
IF NOT "%SILENT%"=="true" PAUSE
ECHO rem This is generated by patch_install.bat > %uninst%
ECHO rem This batch file could retore your original modules from an interim fix installation >> %uninst%
ECHO rem Please do not modify this file >> %uninst%
FOR /F %%i IN (%ITMVER%\file_list.txt) DO ( IF EXIST %ITM_HOME%\%%i ( ECHO XCOPY /Y backup\%%i %ITM_HOME%\%%i >> %uninst% ) )
REM UNINSTALL VERSION FILES
FOR /F %%i IN (version_files.txt) DO ( IF EXIST %ITM_HOME%\%%i ( ECHO COPY /Y /V backup\%%i %ITM_HOME%\%%i >> %uninst% ) )
GOTO startInst


:startInst
CLS
set i=
ECHO We are going to install the interim fix to the directory %ITM_HOME%
ECHO If you don't want that, 
ECHO or IF this is not correct, press CTRL-BREAK now,
IF NOT "%SILENT%"=="true" PAUSE
ECHO Ok, we're going...
FOR /F %%i IN (%ITMVER%\file_list.txt) DO ( IF EXIST %ITM_HOME%\%%i ( @xcopy /Y %ITMVER%\%%i %ITM_HOME%\%%i ) ELSE ( SET missed=yes ) )
goto replace

:replace
REM version files update from 06010000 to 06010001
set oldver="VRMF=06010001"
set oldver1="VRMF=06010000"
set newver="VRMF=06010002"
FOR /F %%i IN (version_files.txt) DO (
	IF EXIST %ITM_HOME%\%%i (
		replace %ITM_HOME%\%%i tmp %oldver% %newver%
		if "!errorlevel!" == "1" (
			@copy /Y /V  tmp %ITM_HOME%\%%i
			
		)
		replace %ITM_HOME%\%%i tmp %oldver1% %newver%
		if "!errorlevel!" == "1" (
			@copy /Y /V  tmp %ITM_HOME%\%%i
			
		)
		@del /Q tmp
	)
)

goto result

:result
set i=
echo *************************************************************
echo *************************************************************
IF %missed%==yes ECHO Below file(s) were not copied during this installation.
IF %missed%==yes ECHO Because they do not exist in your directory, probably you did not install the related component, it is normal
IF %missed%==yes ECHO This is normal.
IF %missed%==yes ( For /F %%i IN (%ITMVER%\file_list.txt) DO ( IF NOT EXIST %ITM_HOME%\%%i ECHO %%i ) )
IF %missed%==yes ECHO *************************************************************
IF %missed%==yes ECHO *************************************************************
ECHO Install complete
goto endpro

:no_param
ECHO You did not specify your ITM installation path
ECHO Try to use the default one - C:\IBM\ITM
set ITM_HOME=C:\IBM\ITM
IF not EXIST %ITM_HOME%\License  ECHO Could not find directory %ITM_HOME%\License, press any key ...
IF not EXIST %ITM_HOME% GOTO queryITM

:queryITM
pause
ECHO Please input your ITM folder:
SET /P ITM_HOME=
IF not EXIST %ITM_HOME%\License  ( ECHO Could not find directory %ITM_HOME%\License  ) ELSE GOTO genUninstall
IF not EXIST %ITM_HOME%\License  GOTO queryITM

rem :errorend
rem ECHO ERROR! Program is ending ...
rem GOTO endpro

:getVersion

%ITM_HOME%\InstallITM\KinCInfo.exe -i > info
setlocal ENABLEDELAYEDEXPANSION
echo MS >comp
echo CW >>comp
echo CJ >>comp
echo CQ >>comp
echo GL >>comp
echo OS >>comp
echo UA >>comp
rem echo UI >>comp
FOR /F  %%j IN (comp) DO (
	rem set MYvar=
	FIND "%%j    "  <info >match
	set /p MYvar=<match
 
)

set FOUND=
set VER=
FOR /F "delims=!" %%i IN (info) DO (if  "%MYvar%" == "%%i" ( set FOUND=123) ELSE ( if "!FOUND!" == "123" SET FOUND=%%i ))
ECHO %FOUND% > info
rem ECHO %FOUND% 
FOR /F "tokens=2 delims=." %%i IN (info) DO SET VER=%%i
REM ECHO VER=%VER%
IF "%VER%" == "20" SET ITMVER=ITM62
IF "%VER%" == "10" SET ITMVER=ITM61
@del /Q info
@del /Q match
@del /Q comp
rem echo ITMVER=%ITMVER%
IF "%ITMVER%" == "" ( ECHO ---------CANNOT GET ITM VERSION INFO------- )ELSE GOTO gotVersion

:endpro
